## dpdk 23.11

=== Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2010-2020 Intel Corporation

.PHONY: all
all:
	@echo "To build DPDK please use meson and ninja as described at"
	@echo "    https://core.dpdk.org/doc/quick-start/"

=== examples/l2fwd-event/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(C) 2019 Marvell International Ltd.
#

# binary name
APP = l2fwd-event

# all source are stored in SRCS-y
SRCS-y := main.c
SRCS-y += l2fwd_poll.c
SRCS-y += l2fwd_event.c
SRCS-y += l2fwd_common.c
SRCS-y += l2fwd_event_generic.c
SRCS-y += l2fwd_event_internal_port.c

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -DALLOW_EXPERIMENTAL_API

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== examples/ptpclient/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2015 Intel Corporation

# binary name
APP = ptpclient

# all source are stored in SRCS-y
SRCS-y := ptpclient.c

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -DALLOW_EXPERIMENTAL_API

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== examples/multi_process/symmetric_mp/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2010-2014 Intel Corporation

# binary name
APP = symmetric_mp

# all source are stored in SRCS-y
SRCS-y := main.c

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -DALLOW_EXPERIMENTAL_API

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== examples/server_node_efd/efd_server/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2016-2020 Intel Corporation

# binary name
APP = server

# all source are stored in SRCS-y
SRCS-y := main.c init.c args.c

CFLAGS += -I../shared

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk)
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -DALLOW_EXPERIMENTAL_API

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared
	test -d build && rmdir -p build || true

=== drivers/net/tap/bpf/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# This file is not built as part of normal DPDK build.
# It is used to generate the eBPF code for TAP RSS.

CLANG=clang
CLANG_OPTS=-O2
TARGET=../tap_bpf_insns.h

all: $(TARGET)

clean:
	rm tap_bpf_program.o $(TARGET)

tap_bpf_program.o: tap_bpf_program.c
	$(CLANG) $(CLANG_OPTS) -emit-llvm -c $< -o - | \
	llc -march=bpf -filetype=obj -o $@

$(TARGET): tap_bpf_program.o
	python3 bpf_extract.py -stap_bpf_program.c -o $@ $<

=== debian/changelog ===
dpdk (23.11-1ubuntu0.1) noble-security; urgency=medium

  * SECURITY UPDATE: DoS via OOB read in checksum offload feature
    - debian/patches/CVE-2024-11614.patch: fix Rx checksum calculation in
      lib/vhost/virtio_net.c.
    - CVE-2024-11614

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 18 Dec 2024 13:31:38 -0500

dpdk (23.11-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:04:08 +0000

dpdk (23.11-1build2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 17:46:33 +0000

dpdk (23.11-1build1) noble; urgency=medium

  * No-change rebuild against libelf1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 01 Mar 2024 00:57:16 +0000

dpdk (23.11-1) unstable; urgency=medium

  * Upload to unstable.

 -- Luca Boccassi <bluca@debian.org>  Mon, 18 Dec 2023 11:55:09 +0100

dpdk (23.11-1~exp1) experimental; urgency=medium

  * New upstream release 23.11; for a full list of changes see:
    http://doc.dpdk.org/guides-23.11/rel_notes/release_23_11.html

  [ Christian Ehrhardt ]
  * New upstream release candidate 23.11-rc3
    - d/p/*: update to match 23.11
      - disable_ now list files instead of test names
      - testpmd-fix-early-exit-from-signal.patch was applied upstream
      - 0001-eal-linux-force-iova-mode-va-with-no-huge-option.patch is
        no more applicable and didn't went upstream
    - d/*.symbols: rename and update to match the ABI change to 24
    - d/control: Bump to 23.11 ABI 24
    - d/control: added/remove libraries for 23.11
    - d/dpdk-dev.install: sort and add new test binaries
    - d/dpdk-dev.lintian-overrides: more admin tools without manpages
    - d/dpdk-doc.lintian-overrides: flow_classify was dropped
    - d/copyright: kni dropped, update debian/* dates and updated
      based on SPDX tags
    - d/*.symbols: mark internal symbols as optional
    - d/p/fix-riscv-march.patch: fix riscv build
    - d/p/disable_autopkgtest_fails.patch: add back table test to fix linking
      issues
    - d/p/disable_*: drop as all formerly bad tests seem now to be ok
    - d/rules: enable LTO
    - d/p/Fix-ppc64-test-via-iova-setting.patch: replace former
      d/p/0001-eal-linux-force-iova-mode-va-without-pa-available.patch never
      accepted upstream with something only changing test behavior and not the
      general EAL operation of commandline options

  [ Luca Boccassi ]
  * d/watch: move to 23.11 LTS
  * Update upstream source from tag 'upstream/23.11-rc4'
  * Drop fix-riscv-march.patch, merged upstream
  * d/rules: do not run unit tests at build time
  * cdx, cpfl and mana PMDs are built for i386 too
  * Update Lintian override for examples mistaken as documentation
  * Add symbols files for new libraries
  * Set version of DPDK_24 to 23.11 in symbols files
  * enable all reproducible build flags
  * Drop i386 support

 -- Luca Boccassi <bluca@debian.org>  Wed, 29 Nov 2023 02:01:20 +0000

dpdk (22.11.3-2) unstable; urgency=medium

  * Team upload.

  [ Luca Boccassi ]
  * d/rules: bump test timeout multiplier from 6 to 10

  [ Frode Nordahl ]
  * d/p/testpmd-fix-early-exit-from-signal.patch: Cherry-pick fix for
    LP:#2040097.

 -- Frode Nordahl <frode.nordahl@canonical.com>  Sun, 29 Oct 2023 12:28:18 +0100

=== debian/rules ===
#!/usr/bin/make -f

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all
DEB_CFLAGS_MAINT_APPEND = -flto=auto -ffat-lto-objects
DEB_CXXFLAGS_MAINT_APPEND = -flto=auto -ffat-lto-objects
DEB_LDFLAGS_MAINT_APPEND = -flto=auto -ffat-lto-objects
include /usr/share/dpkg/default.mk

# Upstream now defines a single ABI across all libs that we will use
DPDK_ABI := $(shell cat ABI_VERSION | cut -d. -f1)
# Experimental libs will have 0.200 on actual ABI 20.0
DPDK_EXP_ABI := "0.$(shell cat ABI_VERSION | cut -d. -f1-2 | tr -d ".")"

ifeq (,$(findstring terse,$(DEB_BUILD_OPTIONS)))
	export DH_VERBOSE=1
	export DH_OPTIONS=-v
endif

# People rebuilding this package can overwrite RTE_PLATFORM
# via DEB_BUILD_OPTIONS if they like
ifneq (,$(filter rte_machine=%,$(DEB_BUILD_OPTIONS)))
	echo "WARNING: the machine setting is deprecated, please use platform (rte_platform)"
    RTE_PLATFORM ?= $(patsubst rte_machine=%,%,$(filter rte_platform=%,$(DEB_BUILD_OPTIONS)))
endif
ifneq (,$(filter rte_platform=%,$(DEB_BUILD_OPTIONS)))
    RTE_PLATFORM ?= $(patsubst rte_platform=%,%,$(filter rte_platform=%,$(DEB_BUILD_OPTIONS)))
endif
# default to minimal base, without setting this it would build
# -march=native which is a non portable invariant
RTE_PLATFORM ?= "generic"

ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
BUILD_DOCS=n
else
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
BUILD_DOCS=n
# to stop dh_installdoc from running
export DEB_BUILD_PROFILES += nodoc
else
BUILD_DOCS=y
endif
endif

# Allow to pass specific configure flags to meson as a comma separated list
ifneq (,$(filter dpdk_config_options=%,$(DEB_BUILD_OPTIONS)))
# GNU Makefile hack: can't directly escape comma and spaces, so use variables
    comma := ,
    empty :=
    space := $(empty) $(empty)
    DPDK_CONFIG_OPTIONS ?= $(subst $(comma),$(space),$(patsubst dpdk_config_options=%,%,$(filter dpdk_config_options=%,$(DEB_BUILD_OPTIONS))))
endif

%:
	dh $@ --with python3 --buildsystem=meson

override_dh_gencontrol:
	dh_gencontrol
	# debian/files will not exist until dh_gencontrol has ran at least once,
	# so we need to run gencontrol for libdpdk-dev after.
	# The list of libraries and PMDs is everchanging, so generate the dependency
	# list for libdpdk-dev to avoid having to maintain it manually.
	# Various meta packages help users to gain a granular access per lib-subtype.
	# The recommends list for dpdk has more common libs, all full meta categories
	# are listed as suggests.
	dh_gencontrol -p libdpdk-dev          -- -V"librte:All=`grep      -E 'librte-*'           ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-all      -- -V"librte:All=`grep      -E 'librte-*'           ./debian/files | grep -v dbgsym | grep -v 'librte-meta-' | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-baseband -- -V"librte:Baseband=`grep -E 'librte-baseband-.*' ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-bus      -- -V"librte:Bus=`grep      -E 'librte-bus-.*'      ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-common   -- -V"librte:Common=`grep   -E 'librte-common-.*'   ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-compress -- -V"librte:Compress=`grep -E 'librte-compress-.*' ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-crypto   -- -V"librte:Crypto=`grep   -E 'librte-crypto-.*'   ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-dma      -- -V"librte:Dma=`grep      -E 'librte-dma-.*'      ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-event    -- -V"librte:Event=`grep    -E 'librte-event-.*'    ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-mempool  -- -V"librte:Mempool=`grep  -E 'librte-mempool-.*'  ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-net      -- -V"librte:Net=`grep      -E 'librte-net-.*'      ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-raw      -- -V"librte:Raw=`grep      -E 'librte-raw-.*'      ./debian/files | grep -v dbgsym                          | tr '_' ' ' | awk '{ print $$1,"(=",$$2 ")" }' | paste -sd ',' - | sed -e 's/,/, /g'`"
	dh_gencontrol -p librte-meta-allpmds -- -V"librte:Allpmds=`for pmd in $$(find -type d -wholename './debian/librte-*dpdk/pmds-*'); do awk -v "ver=$(DEB_VERSION)" '/^Package:/ {printf("%s (= %s), \n",$$2,ver)}' "$${pmd}/../../../../../DEBIAN/control"; done | LC_ALL=C sort --stable | xargs`"

override_dh_auto_clean:
	rm -f doc/guides/compressdevs/overview_feature_table.txt \
		doc/guides/cryptodevs/overview_aead_table.txt \
		doc/guides/cryptodevs/overview_asym_table.txt \
		doc/guides/cryptodevs/overview_auth_table.txt \
		doc/guides/cryptodevs/overview_cipher_table.txt \
		doc/guides/cryptodevs/overview_feature_table.txt \
		doc/guides/nics/overview_table.txt
	# test directory for sockets, etc
	rm -rf $(CURDIR)/tmpdir
	# every PMD package has a ldconfig-escape lintian warning, so we generate an override, delete them on cleanup
	find debian -type f \( -iname "librte-*.lintian-overrides" ! -iname "librte-meta*.lintian-overrides" \) -delete
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure -- $(DPDK_CONFIG_OPTIONS) \
		--includedir=include/dpdk \
		--default-library=shared \
		-Dinclude_subdir_arch=../$(DEB_HOST_MULTIARCH)/dpdk \
		-Dplatform=$(RTE_PLATFORM) \
		-Db_lto=true
	head obj-$(DEB_HOST_GNU_TYPE)/compile_commands.json || find . -name compile_commands.json
	grep --max-count=1 -e '-mcpu=' -e '-march=' \
		obj-$(DEB_HOST_GNU_TYPE)/compile_commands.json
	grep -q -e '-mcpu=power8' -e '-march=corei7' -e '-march=armv8-a+crc' -e '-march=rv64gc' \
		obj-$(DEB_HOST_GNU_TYPE)/compile_commands.json \
		|| (echo "Error: unexpected target cpu"; exit 1)

override_dh_auto_build-indep:
ifeq (y,$(BUILD_DOCS))
	dh_auto_build -- doc
	# NINJA DOC INSTALL DOES NOT WORK - .buildinfo present, css missing
	rm -rf obj-$(DEB_HOST_MULTIARCH)/doc/guides/guides/.buildinfo obj-$(DEB_HOST_MULTIARCH)/doc/guides/html/.doctrees
endif

# ninja install doc does not work, will rebuild everything,
# only dpdk-doc as arch: all so just skip it
override_dh_auto_install-indep:

override_dh_auto_install-arch:
	dh_auto_install
	# Package(s): libdpdk-<NAME><VER> (bare runtime libs and PMDs)
	# if lib names end in a number, insert a "-"
	# if libraries are fully experimental set zero as package name suffix, otherwise DPDK_ABI
	# every PMD package has a ldconfig-escape lintian warning, so we generate an override
	for lib in $$(ls -1 debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.so.*); do \
	  LN=$$(basename $${lib} | sed -e 's/\.so\.[0-9\.]*$$//' | tr '_' '-'); \
	  if echo $${LN} | grep -q ".*[0-9]$$"; then \
	    PKG="$${LN}-"; \
	  else \
	    PKG="$${LN}"; \
	  fi; \

## dpdk 23.11.1

=== debian/changelog ===
dpdk (23.11.1-1) unstable; urgency=medium

  [ Luca Boccassi ]
  * Drop riscv64 from libraries that are not built for it

  [ Christian Ehrhardt ]
  * d/rules: clean up stray build artifacts (Closes: #1045122)

  [ Luca Boccassi ]
  * Build depend on pkgconf instead of pkg-config
  * Drop unused Lintian override

  [ Christian Ehrhardt ]
  * d/rules, d/control, d/*.symbols: Add loong64 support (Closes:
    #1059972)

  [ Luca Boccassi ]
  * Enable ELF metadata stamping
  * d/rules: disable dh verbose flags
  * Bump Standards-Version to 4.7.0, no changes
  * Update upstream source from tag 'upstream/23.11.1'
  * Update symbols files for internal symbols removals

 -- Luca Boccassi <bluca@debian.org>  Fri, 17 May 2024 12:19:41 +0100

=== debian/control ===
Source: dpdk
Priority: optional
Maintainer: Debian DPDK Maintainers <pkg-dpdk-devel@lists.alioth.debian.org>
Uploaders: Luca Boccassi <bluca@debian.org>,
           Christian Ehrhardt <christian.ehrhardt@canonical.com>,
           Santiago Ruano Rincón <santiagorr@riseup.net>,
Build-Depends: chrpath,
               debhelper-compat (= 13),
               dh-package-notes,
               dh-python,
               libbpf-dev,
               libbsd-dev,
               libelf-dev,
               libfdt-dev,
               libibverbs-dev (>= 23~),
               libipsec-mb-dev [amd64],
               libisal-dev [amd64],
               libjansson-dev,
               libmnl-dev,
               libnuma-dev,
               libpcap-dev,
               libssl-dev,
               libxdp-dev,
               meson (>= 0.47.1~),
               pkgconf,
               python3:any,
               python3-pyelftools,
               zlib1g-dev,
Build-Depends-Indep:
               doxygen <!nodoc>,
               graphviz <!nodoc>,
               inkscape <!nodoc>,
               python3-sphinx <!nodoc>,
               python3-sphinx-rtd-theme <!nodoc>,
               texlive-fonts-recommended <!nodoc>,
               texlive-latex-extra <!nodoc>,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Section: libs
Homepage: https://www.dpdk.org
Vcs-Git: https://salsa.debian.org/debian/dpdk.git -b unstable
Vcs-Browser: https://salsa.debian.org/debian/dpdk

Package: dpdk
Section: admin
Architecture: amd64 arm64 ppc64el riscv64 loong64
Depends: pci.ids | hwdata,
         pciutils,
         procps,
         ${misc:Depends},
         ${python3:Depends},
# Recommend a subset of more tested, more used and more supported libs
Recommends: librte-mempool24,
            librte-mempool-ring24,
            librte-net-af-packet24,
            librte-net-bond24,
            librte-net-e1000-24,
            librte-net-fm10k24,
            librte-net-i40e24,
            librte-net-ixgbe24,
            librte-net-mlx4-24,
            librte-net-mlx5-24,
            librte-net-netvsc24,
            librte-net-pcap24,
            librte-net-tap24,
            librte-net-thunderx24,
            librte-net-vdev-netvsc24,
            librte-net-vhost24,
            librte-net-virtio24,
            librte-net-vmxnet3-24,
            python3-pyelftools,
Suggests: dpdk-doc,
          dpdk-kmods-dkms,
          librte-meta-baseband,
          librte-meta-bus,
          librte-meta-common,
          librte-meta-compress,
          librte-meta-crypto,
          librte-meta-dma,
          librte-meta-event,
          librte-meta-mempool,
          librte-meta-net,
          librte-meta-raw,
          librte-meta-allpmds,
Breaks: dpdk-dev (<< 18.11-4~),
Replaces: dpdk-dev (<< 18.11),
Description: Data Plane Development Kit (runtime)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime environment to run DPDK applications.

Package: librte-meta-baseband
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Baseband},
         ${misc:Depends},
Description: Data Plane Development Kit (baseband libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte baseband libraries.

Package: librte-meta-bus
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Bus},
         ${misc:Depends},
Description: Data Plane Development Kit (bus libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte bus libraries.

Package: librte-meta-common
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Common},
         ${misc:Depends},
Description: Data Plane Development Kit (common libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte common libraries.

Package: librte-meta-compress
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Compress},
         ${misc:Depends},
Description: Data Plane Development Kit (compress libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte compress libraries.

Package: librte-meta-crypto
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Crypto},
         ${misc:Depends},
Description: Data Plane Development Kit (crypto libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte crypto libraries.

Package: librte-meta-dma
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Dma},
         ${misc:Depends},
Description: Data Plane Development Kit (dma libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte dma libraries.

Package: librte-meta-event
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Event},
         ${misc:Depends},
Description: Data Plane Development Kit (event libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte event libraries.

Package: librte-meta-mempool
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Mempool},
         ${misc:Depends},
Description: Data Plane Development Kit (mempool libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte mempool libraries.

Package: librte-meta-net
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Net},
         ${misc:Depends},
Description: Data Plane Development Kit (net libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte net libraries.

Package: librte-meta-raw
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Raw},
         ${misc:Depends},
Description: Data Plane Development Kit (raw libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all the librte raw libraries.

Package: librte-meta-allpmds
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:Allpmds},
         ${misc:Depends},
Description: Data Plane Development Kit (all poll mode drivers)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all poll mode drivers produced by DPDK.

Package: librte-meta-all
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Depends: ${librte:All},
         ${misc:Depends},
Description: Data Plane Development Kit (all sub-libraries)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This is a metapackage to pull in all librte libraries produced by DPDK.

Package: dpdk-dev
Section: oldlibs
Architecture: amd64 arm64 ppc64el riscv64 loong64
Breaks: dpdk (<< 18.11-4~),
Replaces: dpdk (<< 18.11-4),
Depends: libdpdk-dev (>= ${source:Version}),
         python3,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Data Plane Development Kit (dev tools)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains tools useful to a developer and for dpdk self tests.

Package: dpdk-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Homepage: https://dpdk.org/doc/guides/index.html
Depends: fonts-font-awesome,
         fonts-lato,
         fonts-roboto-slab,
         libjs-jquery,
         libjs-underscore,
         python3:any,
         ${misc:Depends},
         ${python3:Depends},
Recommends: ${python3:Recommends},
Description: Data Plane Development Kit (documentation)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the complete set of documentation and guides.

Package: libdpdk-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: libbpf-dev,
         libbsd-dev,
         libibverbs-dev,
         libipsec-mb-dev [amd64],
         libisal-dev [amd64],
         libelf-dev,
         libfdt-dev,
         libjansson-dev,
         libmnl-dev,
         libnuma-dev,
         libpcap-dev,
         libssl-dev,
         libxdp-dev,
         zlib1g-dev,
         ${librte:All},
         ${misc:Depends},
Description: Data Plane Development Kit (basic development files)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the basic headers and library files required to
 build external applications which will also require at least SSE3 support
 when running.
 .
 libdpdk.pc: note that CFLAGS might contain an -march flag higher than typical
 baseline.
 This is required for a number of static inline functions in the public headers.

Package: librte-acl24
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Homepage: https://dpdk.org/doc/api/rte__acl_8h.html
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Conflicts: libdpdk0,
Description: Data Plane Development Kit (librte-acl runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte-acl.

Package: librte-baseband-acc24
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Homepage: https://doc.dpdk.org/guides/bbdevs/acc100.html
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Conflicts: libdpdk0,
Description: Data Plane Development Kit (librte-baseband-acc100 runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run
 in user-space and communicate directly with dedicated network interfaces.
 .
 This package contains the runtime libraries for librte-baseband-acc100.

Package: librte-baseband-fpga-5gnr-fec24
Architecture: amd64 arm64 ppc64el riscv64 loong64
Multi-Arch: same
Homepage: https://doc.dpdk.org/guides/bbdevs/fpga_5gnr_fec.html
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Conflicts: libdpdk0,
Description: Data Plane Development Kit (librte-baseband-fpga-5gnr-fec runtime library)
 DPDK is a set of libraries for fast packet processing. Applications run

## dpdk 23.11.2

=== examples/multi_process/simple_mp/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2010-2014 Intel Corporation

# binary name
APP = simple_mp

# all source are stored in SRCS-y
SRCS-y := main.c mp_commands.c
SRC-DEPS := build/commands.h

PKGCONF ?= pkg-config

# Build using pkg-config variables if possible
ifneq ($(shell $(PKGCONF) --exists libdpdk && echo 0),0)
$(error "no installation of DPDK found")
endif

all: shared
.PHONY: shared static
shared: build/$(APP)-shared
	ln -sf $(APP)-shared build/$(APP)
static: build/$(APP)-static
	ln -sf $(APP)-static build/$(APP)

PC_FILE := $(shell $(PKGCONF) --path libdpdk 2>/dev/null)
CFLAGS += -O3 $(shell $(PKGCONF) --cflags libdpdk) -I build/
LDFLAGS_SHARED = $(shell $(PKGCONF) --libs libdpdk)
LDFLAGS_STATIC = $(shell $(PKGCONF) --static --libs libdpdk)

build/commands.h: commands.list Makefile
	dpdk-cmdline-gen.py -o $@ --context-name=simple_mp_ctx $<

ifeq ($(MAKECMDGOALS),static)
# check for broken pkg-config
ifeq ($(shell echo $(LDFLAGS_STATIC) | grep 'whole-archive.*l:lib.*no-whole-archive'),)
$(warning "pkg-config output list does not contain drivers between 'whole-archive'/'no-whole-archive' flags.")
$(error "Cannot generate statically-linked binaries with this version of pkg-config")
endif
endif

CFLAGS += -DALLOW_EXPERIMENTAL_API

build/$(APP)-shared: $(SRCS-y) Makefile $(PC_FILE) | build $(SRC-DEPS)
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_SHARED)

build/$(APP)-static: $(SRCS-y) Makefile $(PC_FILE) | build $(SRC-DEPS)
	$(CC) $(CFLAGS) $(SRCS-y) -o $@ $(LDFLAGS) $(LDFLAGS_STATIC)

build:
	@mkdir -p $@

.PHONY: clean
clean:
	rm -f build/$(APP) build/$(APP)-static build/$(APP)-shared build/*.h
	test -d build && rmdir -p build || true

=== debian/changelog ===
dpdk (23.11.2-0ubuntu1.1~cloud0) noble-dalmatian; urgency=medium

  * New update for the Ubuntu Cloud Archive.

 -- James Page <james.page@ubuntu.com>  Fri, 20 Dec 2024 08:42:13 +0000

dpdk (23.11.2-0ubuntu1.1) oracular-security; urgency=medium

  * SECURITY UPDATE: DoS via OOB read in checksum offload feature
    - debian/patches/CVE-2024-11614.patch: fix Rx checksum calculation in
      lib/vhost/virtio_net.c.
    - CVE-2024-11614

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 18 Dec 2024 13:30:00 -0500

dpdk (23.11.2-0ubuntu1) oracular; urgency=medium

  * Merge stable release 23.11.2 (LP: #2080354)
    - Full release notes are available at:
      https://doc.dpdk.org/guides-23.11/rel_notes/release_23_11.html#id1 

 -- Miriam España Acebal <miriam.espana@canonical.com>  Thu, 12 Sep 2024 12:03:11 +0200

dpdk (23.11.1-2) unstable; urgency=medium

  * d/control, d/t/control: depend on isa-support packages, so far on
    sse4.2-support on amd64. This shall help to avoid being
    installed on machines that will later crash with SIG_ILL.
    Instead isa-support provides means to detect that at install time
    and some wording about why it was blocked. For more details see
    /usr/share/doc/isa-support/README

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 04 Jul 2024 15:35:34 +0200

=== debian/rules ===
--- 
+++ 
@@ -7,16 +7,17 @@
 DEB_CXXFLAGS_MAINT_APPEND = -flto=auto -ffat-lto-objects
 DEB_LDFLAGS_MAINT_APPEND = -flto=auto -ffat-lto-objects
 include /usr/share/dpkg/default.mk
+include /usr/share/debhelper/dh_package_notes/package-notes.mk
 
 # Upstream now defines a single ABI across all libs that we will use
 DPDK_ABI := $(shell cat ABI_VERSION | cut -d. -f1)
 # Experimental libs will have 0.200 on actual ABI 20.0
 DPDK_EXP_ABI := "0.$(shell cat ABI_VERSION | cut -d. -f1-2 | tr -d ".")"
 
-ifeq (,$(findstring terse,$(DEB_BUILD_OPTIONS)))
-	export DH_VERBOSE=1
-	export DH_OPTIONS=-v
-endif
+#ifeq (,$(findstring terse,$(DEB_BUILD_OPTIONS)))
+#	export DH_VERBOSE=1
+#	export DH_OPTIONS=-v
+#endif
 
 # People rebuilding this package can overwrite RTE_PLATFORM
 # via DEB_BUILD_OPTIONS if they like
@@ -85,11 +86,26 @@
 		doc/guides/cryptodevs/overview_auth_table.txt \
 		doc/guides/cryptodevs/overview_cipher_table.txt \
 		doc/guides/cryptodevs/overview_feature_table.txt \
-		doc/guides/nics/overview_table.txt
+		doc/guides/nics/overview_table.txt \
+		doc/guides/bbdevs/overview_feature_table.txt \
+		doc/guides/cryptodevs/overview_os_table.txt \
+		doc/guides/eventdevs/overview_crypto_adptr_feature_table.txt \
+		doc/guides/eventdevs/overview_feature_table.txt \
+		doc/guides/eventdevs/overview_rx_adptr_feature_table.txt \
+		doc/guides/eventdevs/overview_timer_adptr_feature_table.txt \
+		doc/guides/eventdevs/overview_tx_adptr_feature_table.txt \
+		doc/guides/gpus/overview_feature_table.txt \
+		doc/guides/nics/rte_flow_actions_table.txt \
+		doc/guides/nics/rte_flow_items_table.txt \
+		doc/guides/regexdevs/overview_feature_table.txt \
+		doc/guides/vdpadevs/overview_feature_table.txt
 	# test directory for sockets, etc
 	rm -rf $(CURDIR)/tmpdir
 	# every PMD package has a ldconfig-escape lintian warning, so we generate an override, delete them on cleanup
 	find debian -type f \( -iname "librte-*.lintian-overrides" ! -iname "librte-meta*.lintian-overrides" \) -delete
+	# some python helpers got precompiled in place along the way and are not always cleaned up
+	find . -name '*.pyc' -type f -delete
+	find . -name '__pycache__' -type d -delete
 	dh_auto_clean
 
 override_dh_auto_configure:
@@ -102,31 +118,10 @@
 	head obj-$(DEB_HOST_GNU_TYPE)/compile_commands.json || find . -name compile_commands.json
 	grep --max-count=1 -e '-mcpu=' -e '-march=' \
 		obj-$(DEB_HOST_GNU_TYPE)/compile_commands.json
-	grep -q -e '-mcpu=power8' -e '-march=corei7' -e '-march=armv8-a+crc' -e '-march=rv64gc' \
+	grep -q -e '-mcpu=power8' -e '-march=corei7' -e '-march=armv8-a+crc' -e '-march=rv64gc' -e '-march=loongarch64' \
 		obj-$(DEB_HOST_GNU_TYPE)/compile_commands.json \
 		|| (echo "Error: unexpected target cpu"; exit 1)
 
 override_dh_auto_build-indep:
 ifeq (y,$(BUILD_DOCS))
 	dh_auto_build -- doc
-	# NINJA DOC INSTALL DOES NOT WORK - .buildinfo present, css missing
-	rm -rf obj-$(DEB_HOST_MULTIARCH)/doc/guides/guides/.buildinfo obj-$(DEB_HOST_MULTIARCH)/doc/guides/html/.doctrees
-endif
-
-# ninja install doc does not work, will rebuild everything,
-# only dpdk-doc as arch: all so just skip it
-override_dh_auto_install-indep:
-
-override_dh_auto_install-arch:
-	dh_auto_install
-	# Package(s): libdpdk-<NAME><VER> (bare runtime libs and PMDs)
-	# if lib names end in a number, insert a "-"
-	# if libraries are fully experimental set zero as package name suffix, otherwise DPDK_ABI
-	# every PMD package has a ldconfig-escape lintian warning, so we generate an override
-	for lib in $$(ls -1 debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.so.*); do \
-	  LN=$$(basename $${lib} | sed -e 's/\.so\.[0-9\.]*$$//' | tr '_' '-'); \
-	  if echo $${LN} | grep -q ".*[0-9]$$"; then \
-	    PKG="$${LN}-"; \
-	  else \
-	    PKG="$${LN}"; \
-	  fi; \
